﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=9.8
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: False
#End Region

Sub Process_Globals
	Dim strMode As String
End Sub

Sub Globals
	Dim IME As IME
	Private txtUserName As EditText
	Private txtUserEmail As EditText
	Private txtUserLocation As EditText
	Private txtUserPassword As EditText	
	Private txtUserPassword1 As EditText
	Private txtUserPassword2 As EditText
	Private lblUserName As Label
	Private lblUserEmail As Label
	Private lblUserLocation As Label
	Private btnSubmit As Button
	Private btnCancel As Button
End Sub

Sub Activity_Create(FirstTime As Boolean)
	IME.Initialize("IME")
	'IME.AddHeightChangedEvent
	'IME_HeightChanged(100%y, 0)
End Sub

Sub Activity_Resume
	SelectMode
End Sub

Sub Activity_Pause (UserClosed As Boolean)

End Sub

Sub SelectMode
	Select Case strMode
		Case "Login"
			Activity.RemoveAllViews
			Activity.LoadLayout("Login")
			IME.SetLengthFilter(txtUserEmail, 200)
			IME.SetLengthFilter(txtUserPassword, 20)
			If Starter.DEV Then
				txtUserEmail.Text = Starter.DEMO_EMAIL
				txtUserPassword.Text = Starter.DEMO_PASSWORD
			End If
		Case "Register"
			Activity.RemoveAllViews
			Activity.LoadLayout("Register")
			IME.SetLengthFilter(txtUserName, 200)
			IME.SetLengthFilter(txtUserEmail, 200)
			IME.SetLengthFilter(txtUserPassword1, 20)
			IME.SetLengthFilter(txtUserPassword2, 20)
			If Starter.DEV Then
				txtUserName.Text = "Aeric Poon"
				txtUserEmail.Text = Starter.DEMO_EMAIL
				txtUserPassword1.Text = Starter.DEMO_PASSWORD
				txtUserPassword2.Text = Starter.DEMO_PASSWORD
			End If
		Case "About"
			Activity.RemoveAllViews
			Activity.LoadLayout("About")
			lblUserName.Text = Starter.gUserName
			lblUserEmail.Text = Starter.gUserEmail
			lblUserLocation.Text = Starter.gUserLocation
	End Select
End Sub

Sub lblBack_Click
	IME.HideKeyboard
	Activity.Finish
End Sub

Sub btnReset_Click
	AppPassword.strMode = "Reset"
	StartActivity(AppPassword)
End Sub

Sub btnSubmit_Click
	IME.HideKeyboard
	Select Case strMode
		Case "Login"
			If txtUserEmail.Text.Trim = "" Then
				MsgboxAsync("Please enter your Email", "E R R O R")
				Return
			End If
			If Routine.ValidateEmail(txtUserEmail.Text.Trim) = False Then
				MsgboxAsync("Email format is incorrect", "Error")
				Return
			End If
			If txtUserPassword.Text.Trim = "" Then
				MsgboxAsync("Please enter your Password", "E R R O R")
				Return
			End If
			LoginUser
			Return
		Case "Register"
			If txtUserName.Text.Trim = "" Then
				MsgboxAsync("Please enter your Name", "E R R O R")
				Return
			End If
			If txtUserEmail.Text.Trim = "" Then
				MsgboxAsync("Please enter your Email", "E R R O R")
				Return
			End If
			If Routine.ValidateEmail(txtUserEmail.Text.Trim) = False Then
				MsgboxAsync("Email format is incorrect", "Error")
				Return
			End If
			If txtUserPassword1.Text.Trim = "" Then
				MsgboxAsync("Please enter your Password", "E R R O R")
				Return
			End If
			If txtUserPassword2.Text.Trim = "" Then
				MsgboxAsync("Please confirm your Password", "E R R O R")
				Return
			End If
			If txtUserPassword1.Text.Trim <> txtUserPassword2.Text.Trim Then
				MsgboxAsync("Password not match", "E R R O R")
				Return
			End If
			Msgbox2Async("Are you sure to register?", "C O N F I R M", "Y E S", "", "N O", Null, True)
				Wait For Msgbox_Result (Result As Int)
			If Result = DialogResponse.POSITIVE Then
				RegisterUser
			End If
			Return
		Case "About"
			If btnSubmit.Text = "Edit Profile" Then
				btnSubmit.Text = "Update Profile"
				btnCancel.Visible = True
				txtUserName.Text = lblUserName.Text
				txtUserLocation.Text = lblUserLocation.Text
				lblUserName.Visible = False
				lblUserLocation.Visible = False
				txtUserName.Visible = True
				txtUserLocation.Visible = True				
			Else
				If txtUserName.Text.Trim = "" Then
					MsgboxAsync("Please enter your Name", "E R R O R")
					Return
				End If
				If txtUserLocation.Text.Trim = "" Then
					MsgboxAsync("Please enter your Location", "E R R O R")
					Return
				End If
				UpdateProfile
			End If
	End Select
End Sub

Sub LoginUser
	Dim parser As JSONParser
	Dim job As HttpJob
	Dim List1 As List
	Dim Map1 As Map
	Dim strError As String
	Dim strData As String
	Dim jsn As String
	Dim strUserEmail As String = txtUserEmail.Text.Trim
	Dim strUserPassword As String = txtUserPassword.Text.Trim
	Try
		LogColor("[AppUser] LoginUser", Colors.Blue)
		ProgressDialogShow("Connecting to server...")
		job.Initialize("", Me)
		job.Download(Starter.strURL & "user/connect")
		Wait For (job) JobDone(job As HttpJob)
		ProgressDialogHide
		If job.Success Then
			strData = job.GetString
			'Log(strData)
			job.Release
			parser.Initialize(strData)
				If Routine.isArray(strData) Then
				List1 = parser.NextArray
				Map1 = List1.Get(0)
				If Map1.Get("Connected") = 1 Then
					' Download Info
					ProgressDialogShow("Downloading info...")
					Dim Map2 As Map
					Map2.Initialize
					Map2.Put("eml", strUserEmail)
					Map2.Put("pwd", strUserPassword)
					jsn = Routine.Map2Json(Map2)
					job.Initialize("", Me)
					job.PostString(Starter.strURL & "user/login", jsn)
					Wait For (job) JobDone(job As HttpJob)
					ProgressDialogHide
					If job.Success Then
						strData = job.GetString
						job.Release
						Log(strData)
						parser.Initialize(strData)
						If Routine.isArray(strData) Then
							List1 = parser.NextArray
							Map1 = List1.Get(0)
							If Map1.Get("result") = -1 Then
								If Map1.Get("message") = "Error-No-Result" Then
									ToastMessageShow("Error: Invalid Password", False)
								Else If Map1.Get("message") = "Error-No-Value" Then
									ToastMessageShow("Error: Invalid Parameters", False)
								Else If Map1.Get("message") = "Error-Not-Activated" Then
									ToastMessageShow("Error: Your account is not activated", False)
								Else
									ToastMessageShow("Error: Uncaught error" & CRLF & Map1.Get("message"), False)
								End If
								Return
							End If
							If Map1.Get("message") = "success" Then
								Starter.gUserName = Map1.Get("user_name")
								Starter.gUserEmail = Map1.Get("user_email")
								Starter.gUserLocation = Map1.Get("user_location")
								Starter.gUserAPIKey = Map1.Get("user_api_key")
								Starter.gLogin = 1
							End If
							If Starter.gUserAPIKey = "" Then
								ProgressDialogShow("Getting API Key...")
								Dim Map3 As Map
								Map3.Initialize
								Map3.Put("eml", strUserEmail)
								Map3.Put("pwd", strUserPassword)
								'jsn = Map2Json(Map3)
								jsn = Routine.Map2Json(Map3)
								job.Initialize("", Me)
								job.PostString(Starter.strURL & "user/getapikey", jsn)
								Wait For (job) JobDone(job As HttpJob)
								ProgressDialogHide
								If job.Success Then
									strData = job.GetString
									job.Release
									Log(strData)
									parser.Initialize(strData)
									If Routine.isArray(strData) Then
										List1 = parser.NextArray
										Map1 = List1.Get(0)
										If Map1.Get("result") = -1 Then
											If Map1.Get("message") = "Error-No-Result" Then
												ToastMessageShow("Error: Invalid Email or Password", False)
											Else If Map1.Get("message") = "Error-No-Value" Then
												ToastMessageShow("Error: Invalid Parameters", False)
											Else
												ToastMessageShow("Error: Uncaught error" & CRLF & Map1.Get("message"), False)
											End If
											Return
										End If
										If Map1.Get("message") = "success" Then
											Starter.gUserAPIKey = Map1.Get("user_api_key")
										End If
									Else
										job.Release
										strData = parser.NextValue
										Log(strData)
										ToastMessageShow("Error: Uncaught error" & CRLF & strData, False)
									End If
								Else
									strError = job.ErrorMessage
									job.Release
									Log(strError)
									Routine.ShowConnectionError(strError)
								End If
							End If
							ToastMessageShow("Login successful", False)
							Activity.Finish
						Else
							job.Release
							strData = parser.NextValue
							Log(strData)
							ToastMessageShow("Error: Uncaught error" & CRLF & strData, False)
						End If
					Else
						strError = job.ErrorMessage
						job.Release
						Log(strError)
						Routine.ShowConnectionError(strError)
					End If
				End If
			Else
				job.Release
				strData = parser.NextValue
				Log(strData)
				ToastMessageShow("Error: Uncaught error" & CRLF & strData, False)
			End If
		Else
			strError = job.ErrorMessage
			job.Release
			Log(strError)
			Routine.ShowConnectionError(strError)
		End If
	Catch
		job.Release
		LogColor("[AppUser] LoginUser: " & LastException.Message, Colors.Red)
		ToastMessageShow("Failed to retrieve data", False)	
	End Try
End Sub

Sub RegisterUser
	Dim parser As JSONParser
	Dim job As HttpJob
	Dim strError As String
	Dim strData As String
	Dim jsn As String
	Try
		LogColor("[AppUser] RegisterUser", Colors.Blue)
		Dim Map2 As Map
		Map2.Initialize
		Map2.Put("name", txtUserName.Text.Trim)
		Map2.Put("eml", txtUserEmail.Text.Trim)
		Map2.Put("pwd", txtUserPassword1.Text.Trim)
		jsn = Routine.Map2Json(Map2)
		job.Initialize("", Me)
		job.PostString(Starter.strURL & "user/register", jsn)
		Wait For (job) JobDone(job As HttpJob)
		ProgressDialogHide
		If job.Success Then
			strData = job.GetString
			job.Release
			Log(strData)
			parser.Initialize(strData)
			If Routine.isArray(strData) Then
				Dim List1 As List
				Dim Map1 As Map
				List1 = parser.NextArray
				Map1 = List1.Get(0)
				If Map1.Get("result") = -1 Then
					If Map1.Get("message") = "Error-No-Result" Then
						ToastMessageShow("Error: Invalid Password", False)
					Else If Map1.Get("message") = "Error-No-Value" Then
						ToastMessageShow("Error: Invalid Parameters", False)
					Else If Map1.Get("message") = "Error-Email-Used" Then
						MsgboxAsync("Email already registered!", "E R R O R")
					Else
						ToastMessageShow("Error: Uncaught error" & CRLF & Map1.Get("message"), False)
					End If
					Return
				End If
				If strMode = "Register" Then
					Starter.gUserEmail = txtUserEmail.Text.Trim
				End If
				strMode = "Login"
				SelectMode
			Else
				strData = parser.NextValue
				Log(strData)
				ToastMessageShow("Error: Uncaught error" & CRLF & strData, False)
			End If
		Else
			strError = job.ErrorMessage
			job.Release
			Log(strError)
			Routine.ShowConnectionError(strError)
		End If
	Catch
		job.Release
		LogColor("[AppUser] RegisterUser: " & LastException.Message, Colors.Red)
		ToastMessageShow("Failed to register user", False)
	End Try
End Sub

Sub UpdateProfile
	Dim parser As JSONParser
	Dim job As HttpJob
	Dim strError As String
	Dim strData As String
	Dim jsn As String
	Try
		LogColor("[AppUser] UpdateProfile", Colors.Blue)
		Dim Map2 As Map
		Map2.Initialize
		Map2.Put("key", Starter.gUserAPIKey)
		Map2.Put("user_name", txtUserName.Text.Trim)
		Map2.Put("user_location", txtUserLocation.Text.Trim)		
		jsn = Routine.Map2Json(Map2)
		job.Initialize("", Me)
		job.PostString(Starter.strURL & "user/update", jsn)
		Wait For (job) JobDone(job As HttpJob)
		ProgressDialogHide
		If job.Success Then
			strData = job.GetString
			job.Release
			Log(strData)
			parser.Initialize(strData)
			If Routine.isArray(strData) Then
				Dim List1 As List
				Dim Map1 As Map
				List1 = parser.NextArray
				Map1 = List1.Get(0)
				If Map1.Get("result") = -1 Then
					If Map1.Get("message") = "Error-No-Result" Then
						ToastMessageShow("Error: Profile not found", False)
					Else If Map1.Get("message") = "Error-No-Value" Then
						ToastMessageShow("Error: Invalid Parameters", False)
					Else
						ToastMessageShow("Error: Uncaught error" & CRLF & Map1.Get("message"), False)
					End If
					Return
				End If				
				MsgboxAsync("Profile is updated!", "S U C C E S S")
				Starter.gUserName = txtUserName.Text.Trim
				Starter.gUserLocation = txtUserLocation.Text.Trim
				lblUserName.Text = Starter.gUserName
				lblUserLocation.Text = Starter.gUserLocation				
				btnSubmit.Text = "Edit Profile"
				btnCancel.Visible = False
				txtUserName.Visible = False
				txtUserLocation.Visible = False
				lblUserName.Visible = True
				lblUserLocation.Visible = True
			Else
				strData = parser.NextValue
				Log(strData)
				ToastMessageShow("Error: Uncaught error" & CRLF & strData, False)
			End If
		Else
			strError = job.ErrorMessage
			job.Release
			Log(strError)
			Routine.ShowConnectionError(strError)
		End If
	Catch
		job.Release
		LogColor("[AppUser] UpdateProfile: " & LastException.Message, Colors.Red)
		ToastMessageShow("Failed to update profile", False)
	End Try
End Sub

Sub btnCancel_Click
	Starter.gUserName = txtUserName.Text.Trim
	Starter.gUserLocation = txtUserLocation.Text.Trim
	lblUserName.Text = Starter.gUserName
	lblUserLocation.Text = Starter.gUserLocation
	btnSubmit.Text = "Edit Profile"
	btnCancel.Visible = False
	txtUserName.Visible = False
	txtUserLocation.Visible = False
	lblUserName.Visible = True
	lblUserLocation.Visible = True
End Sub