﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=9.8
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub ShowConnectionError(strError As String)
	If strError.Contains("Unable to resolve host") Then
		ToastMessageShow("Connection failed.", False)
	Else If strError.Contains("timeout") Then
		ToastMessageShow("Connection timeout.", False)
	Else
		ToastMessageShow("Error: " & strError, True)
	End If
End Sub

Sub isArray(str As String) As Boolean
	' Assume simple text does not contain this character
	If str.Contains("[") = True Then
		If str.Contains("SQLSTATE[") = True Then
			Return False
		Else
			Return True
		End If
	Else
		Return False
	End If
End Sub

Sub Map2Json(M As Map) As String
	Dim gen As JSONGenerator
	gen.Initialize(M)
	Return gen.ToString
End Sub

' // Source: http://www.b4x.com/android/forum/threads/validate-a-correctly-formatted-email-address.39803/
Sub ValidateEmail(EmailAddress As String) As Boolean
	Dim MatchEmail As Matcher = Regex.Matcher("^(?i)[a-z0-9!#$%&'*+/=?^_`{|}~-]+(?:\.[a-z0-9!#$%&'*+/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])$", EmailAddress)
 
	If MatchEmail.Find = True Then
		'Log(MatchEmail.Match)
		Return True
	Else
		'Log("Oops, please double check your email address...")
		Return False
	End If
End Sub